program Johnson;

{$APPTYPE CONSOLE}

uses
  SysUtils;
Type
  TJob = record
          name:char;
          t1: integer;
          t2: integer;
  end;
  TJobs = array[1..20] of TJob;
  TWA   = array[1..20] of char;
  TCA   = array[0..1000]of char;
var
  n, count, min,max,mincount,maxcount:    integer;
  Jobs:TJobs;
  f,g:  textfile;
  WA,PA: TWA;
  CA1,CA2:TCA;
  h1,h2:integer;
procedure spaces;
var i:integer;
begin
  for i := 0 to 1000 do CA1[i] := ' ';
  h1 := 0;
  for i := 0 to 1000 do CA2[i] := ' ';
  h2 := 0;
end;
procedure Copynames(n:integer; var Jobs:TJobs;var WA:TWA);
var
  i:Integer;
begin
  for I := 1 to n do
     WA[i] := Jobs[i].name;
end;
procedure readdata(var n:integer;var Jobs:TJobs);
begin
  n := 0;
  assignfile(f,'Johnson.txt');
  reset(f);
  while not eof(f) do begin
    inc(n);
    with Jobs[n] do
      readln(f,name,t1,t2);
  end;
end;
procedure printdata(n:integer;var Jobs:TJobs);
var
  i:integer;
begin
  for i := 1 to n do
    with Jobs[i] do
      if name <> ' ' then writeln(g,name:8,t1:8,t2:8);
end;
procedure printperm(n,count:integer;var PA:TWA);
var
  i:integer;
begin
  if count > 0 then write(g,count:5,' ') else write(g,'Johnsonovo reseni: ');
  for i := 1 to n do write(g,PA[i]);
  writeln(g);
end;
function find1(c:char;n:integer):integer;
var
  i :integer;
begin
  find1 := 0;
  for i := 1 to n do
    if Jobs[i].name = c then find1 := Jobs[i].t1;
end;
function find2(c:char;n:integer):integer;
var
  i :integer;
begin
  find2 := 0;
  for i := 1 to n do
    if Jobs[i].name = c then find2 := Jobs[i].t2;
end;
procedure calcul(n:integer; var PA:TWA);
var
  i,j,hm,last:integer;
begin
  Spaces;
  for i:= 1 to n do begin
      hm := find1(PA[i],n);
      for j := 1 to hm do begin
          CA1[h1] :=  PA[i];
          inc(h1);
      end;
  end;
  for i := 0 to h1 do write(g,CA1[i]);
  writeln(g);
  for i:= 1 to n do begin
      hm := find2(PA[i],n);
      last := 0;
      for j := 0 to h1 do
        if PA[i] = CA1[j] then last := j;
      if last+1 > h2 then h2 := last + 1;
      for j := 1 to hm do begin
          CA2[h2] :=  PA[i];
          inc(h2);
      end;
  end;
  for i := 0 to h2 do write(g,CA2[i]);
  writeln(g);
  for i := 0 to h2 do write(g,i mod 10);
  writeln(g);
  for i := 0 to h2 do write(g,(i div 10) mod 10);
  writeln(g);
  writeln(g,'Leadtime = ',h2);
  writeln(g);
  if h2 = max then inc(maxcount);
  if h2 = min then inc(mincount);
  if h2 > max then begin max := h2; maxcount := 1 end;
  if h2 < min then begin min := h2; mincount := 1 end;

end;
procedure permutace(m,n:integer;var WA:TWA);
var
  i,j,k:integer;
  HWA:TWA;
begin
  if n = 0 then begin
    printperm(m,count,PA);
    calcul(m,PA);
    inc(count);
  end;
  for i := 1 to n do begin
    PA[m] := WA[i];
    j := 1;
    for k := 1 to n do
      if k <> i then   begin
         HWA[j] := WA[k];
         inc(j);
    end;
    permutace(m+1,n-1,HWA);
  end;
end;
procedure subJohnson(n:integer;Jobs:TJobs);
var
  i,j,m, a1,a2, i1,i2:integer;
begin
  for i :=1 to n do PA[i] := ' ';
  m := n;
  while m >0 do begin
      a1 := MaxInt;
      a2 := Maxint;
      i1 := 0;   // formalne
      i2 := 0;
      for i := 1 to n do
        with Jobs[i] do begin
        if (name <> ' ') and (a1 > t1) then begin i1 := i; a1 := t1; end;
        if (name <> ' ') and (a2 > t2) then begin i2 := i; a2 := t2; end;
      end;
      if a1 < a2 then begin
        j := 1;
        while PA[j] <> ' ' do inc(j);
        PA[j] := Jobs[i1].name;
        Jobs[i1].name := ' ';
      end else begin
        j := n;
        while PA[j] <> ' ' do dec(j);
        PA[j] := Jobs[i2].name;
        Jobs[i2].name := ' ';
      end;
      dec(m);
  end;
  printperm(n,0,PA);
  calcul(N,PA);
  end;
begin
  AssignFile(g,'Johnson.prn');
  rewrite(g);
  readdata(n,Jobs);
  writeln(g,'n = ',n);
  printdata(n,Jobs);
  Copynames(n,Jobs,WA);
  subJohnson(n,Jobs);
  count := 1;
  max := 0;
  min := MaxInt;
  permutace(1,n,WA);
  writeln(g);
  writeln(g,'Min = ',min,' Max = ',max,
            ' MinCount = ',Mincount,' Maxcount = ',MaxCount);
  closefile(g);
end.
